---
title: HTMLCollection
slug: Web/API/HTMLCollection
tags:
  - API
  - DOM
  - Element Lists
  - HTMLCollection
  - Interface
  - Reference
---
<p>{{APIRef("DOM")}}</p>

<p>The <strong><code>HTMLCollection</code></strong> interface represents a generic collection (array-like object similar to {{jsxref("Functions/arguments", "arguments")}}) of elements (in document order) and offers methods and properties for selecting from the list.</p>

<div class="note"><strong>Note:</strong> This interface is called <code>HTMLCollection</code> for historical reasons (before the modern DOM, collections implementing this interface could only have HTML elements as their items).</div>

<p>An <code>HTMLCollection</code> in the HTML DOM is live; it is automatically updated when the underlying document is changed.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("HTMLCollection.length")}} {{readonlyInline}}</dt>
 <dd>Returns the number of items in the collection.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("HTMLCollection.item()")}}</dt>
 <dd>Returns the specific node at the given zero-based <code>index</code> into the list. Returns <code>null</code> if the <code>index</code> is out of range.</dd>
 <dd>An alternative to accessing <code>collection[<var>i</var>]</code> (which instead returns  <code>undefined</code> when <code><var>i</var></code> is out-of-bounds). This is mostly useful for non-JavaScript DOM implementations.</dd>
 <dt>{{domxref("HTMLCollection.namedItem()")}}</dt>
 <dd>Returns the specific node whose ID or, as a fallback, name matches the string specified by <code>name</code>. Matching by name is only done as a last resort, only in HTML, and only if the referenced element supports the <code>name</code> attribute. Returns <code>null</code> if no node exists by the given name.</dd>
 <dd>An alternative to accessing <code>collection[<var>name</var>]</code> (which instead returns <code>undefined</code> when <code><var>name</var></code> does not exist). This is mostly useful for non-JavaScript DOM implementations.</dd>
</dl>

<h2 id="Usage_in_JavaScript">Usage in JavaScript</h2>

<p><code>HTMLCollection</code> also exposes its members directly as properties by both name and index. HTML IDs may contain <code>:</code> and <code>.</code> as valid characters, which would necessitate using bracket notation for property access. Currently <code>HTMLCollections</code> does not recognize purely numeric IDs, which would cause conflict with the array-style access, though HTML5 does permit these.</p>

<p>For example, assuming there is one <code>&lt;form&gt;</code> element in the document and its <code>id</code> is <code>myForm</code>:</p>

<pre class="brush:js notranslate">var elem1, elem2;

// document.forms is an HTMLCollection

elem1 = document.forms[0];
elem2 = document.forms.item(0);

alert(elem1 === elem2); // shows: "true"

elem1 = document.forms.myForm;
elem2 = document.forms.namedItem("myForm");

alert(elem1 === elem2); // shows: "true"

elem1 = document.forms["named.item.with.periods"];</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#htmlcollection', 'HTMLCollection')}}</td>
   <td>{{ Spec2('DOM WHATWG') }}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLCollection")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("NodeList")}}</li>
 <li>{{domxref("HTMLFormControlsCollection")}}, {{domxref("HTMLOptionsCollection")}}</li>
</ul>
